<template>
  <a-layout-sider width="200" class="sider" style="background: #fff"
                  breakpoint="lg"
                  collapsed-width="0">
    <a-menu
      mode="inline"
      :selected-keys="currentlySelected"
      @click="navigate"
      :style="{ height: '100%', borderRight: 0 }"
    >
      <a-menu-item key="/products">
        Alle Produkte
      </a-menu-item>

      <a-menu-divider></a-menu-divider>

      <template v-for="cat in menuCategories">
        <a-menu-item :key="getPath(cat)">
          {{ cat.name }}
        </a-menu-item>
      </template>
      <a-menu-divider></a-menu-divider>

      <template v-for="cat in normalCategories">
        <a-menu-item :key="getPath(cat)">
          {{ cat.name }}
        </a-menu-item>
      </template>
    </a-menu>
  </a-layout-sider>
</template>
<script lang="ts">
import Vue from 'vue'
import categoriesQuery from '~/apollo/queries/categories/categories.graphql'
import { Category } from '~/types/types'

export default Vue.extend({
  name: 'sidebar',
  computed: {
    currentlySelected (): Array<string> {
      return [this.$route.fullPath]
    },
    menuCategories (): Array<Category> {
      return this.categories.filter((current) => current.inMenu)
    },
    normalCategories (): Array<Category> {
      return this.categories.filter((current) => !current.inMenu)
    }
  },
  methods: {
    navigate(args: any): void {
      this.$router.push(args.key)
    },
    getPath(category: Category): string {
      return '/products?category=' + category.slug
    }
  },
  data () {
    return {
      categories: [] as Array<Category>
    }
  },
  apollo: {
    categories: {
      prefetch: true,
      query: categoriesQuery
    }
  }
})
</script>
<style lang="scss" scoped>

</style>
